<?php

/*
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @category   Troubleticket
 * @package    QuickTicket
 * @author     Philippe Vandenberghe <info@qt-cute.org>
 * @copyright  2007-2010 The PHP Group
 * @license    http://www.php.net/license  PHP License 3.0
 * @version    1.8 build:20080627
 * @link       http://www.qt-cute/doc/package/qti
 * @since      File available since Release 1.0.0
 * @deprecated File deprecated in Release 2.0.0
 *
 */

session_start();
require_once('bin/qti_init.php');
include(Translate($_SESSION[QT]['language'],'qti_lang_adm.inc'));
include(Translate($_SESSION[QT]['language'],'qtim_import_qti.inc'));

if ( $oVIP->role!='A' ) die($L['R_admin']);

// INITIALISE

$strTitle   = '';
$strFormat  = 'CSV';
$strDelimit = ';';
$strEnclose = '"';
$strNull    = 'NULL';
$strDropbbc = 'N';
$strSkip    = 'N';
$strStatus  = 'Z';
$intSection = -1;

$oVIP->selfurl = 'qtim_import_qti_adm.php';
$oVIP->selfname = $L['import_qti']['Admin'];
$oVIP->exiturl = $oVIP->selfurl;
$oVIP->exitname = $oVIP->selfname;
$strPageversion = $L['import_qti']['Version'].' 1.8<br/>';

// --------
// SUBMITTED
// --------

if ( isset($_POST['ok']) )
{
  // check file
  if (!is_uploaded_file($_FILES['title']['tmp_name'])) $qti_error = $L['import_qti']['E_nofile'];

  // check form value
  if ( empty($qti_error) )
  {
    $strFormat = trim($_POST['format']);
    $strDelimit = trim($_POST['delimit']);
    if ( $strFormat=='SQL' ) $strDelimit = ',';
    $strEnclose = $_POST['enclose']; if ( get_magic_quotes_gpc() ) $strEnclose = stripslashes($_POST['enclose']);
    $strNull = trim($_POST['null']);
    if ( isset($_POST['dropbbc']) ) $strDropbbc='Y';
    if ( isset($_POST['skip']) ) $strSkip='Y';
    if ( empty($strDelimit) ) $qti_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    $intSection = intval($_POST['section']);
    $strStatus = $_POST['status'];
    $_SESSION['m_import_qti']=array($strTitle,$strFormat,$strDelimit,$strEnclose,$strNull,$strDropbbc,$strSkip,$intSection,$strStatus);
  }

  // check values
  if ( empty($qti_error) )
  {
    if ( strlen($strDelimit)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strDelimit) ) $qti_error=$L['export']['Delimiter'].S.$L['E_invalid'];
    }
    if ( strlen($strEnclose)==1 )
    {
    if ( ereg("[0-9A-Za-z]",$strEnclose) ) $qti_error=$L['export']['Enclose'].S.$L['E_invalid'];
    }
  }

  // save and run
  if ( empty($qti_error) )
  {
    if ( empty($_POST['null']) ) { $strNull=S; } else { $strNull=$_POST['null']; }

    if ( $_FILES['title']['type']!='text/plain' )
    {
    $qti_error = $L['import_qti']['E_format'];
    unlink($_FILES['title']['tmp_name']);
    }

    // read lines
    $handle = fopen($_FILES['title']['tmp_name'],'r');
    if ( $handle )
    {
      if ( $strSkip=='Y' ) $str = fgets($handle);

      // -----
      $i = 0;
      $intCountPost = 0;
      $intCountTopic = 0;
      $intNextTopic = QTnextid($oDB,TABTOPIC);

      while ( !feof($handle) )
      {
        $i++;
        $str = fgets($handle);
        if ( strlen($str)<4 ) continue;

        if ( $strFormat=='SQL' )
        {
        $str = trim(strstr($str,'VALUES ('));
        $str = substr($str, 8, -1);
        }
        // bbc html
        if ( $strDropbbc=='Y' )
        {
        $str = QTbbc($str,'drop',null,null,null,null,' ');
        }

        // import line (0:id 1:forum 2:topic 3:type 4:username 5:title 6:issuedate 7:numid 8:textmsg 9:x 10:y 11:z
        if ( substr_count($str, $strDelimit)>7 )
        {
          // check dataset size
          $arrStr = explode($strDelimit,$str);
          $intDataset = 0; // not valid
          if ( count($arrStr)==9 ) $intDataset = 9; // valid, without map
          if ( count($arrStr)==12 ) $intDataset = 12; // valid, with map

          if ( $intDataset>0 )
          {
            // pre-process values, remove encloser, html quote
            For ($j=0;$j<$intDataset;$j++)
            {
              $arrStr[$j]=trim($arrStr[$j]);
              if ( substr($arrStr[$j],0,1)==$strEnclose && substr($arrStr[$j],-1,1)==$strEnclose ) $arrStr[$j]=substr($arrStr[$j],1,-1);
              $arrStr[$j] = htmlspecialchars($arrStr[$j],ENT_QUOTES);
            }

            $intPost      = QTnextid($oDB,TABPOST);
            $intTopic     = $intNextTopic+$arrStr[2];
            $strType      = ($arrStr[3]==$strNull ? 'NULL' : '"'.$arrStr[3].'"');
            $strUsername  = ($arrStr[4]==$strNull ? 'NULL' : '"'.$arrStr[4].'"');
            $strTitle     = ($arrStr[5]==$strNull ? 'NULL' : '"'.$arrStr[5].'"');
            $intIssuedate = ($arrStr[6]==$strNull ? 'NULL' : SQLdate($oDB,$arrStr[6]));
            $intNumid     = $arrStr[7];
            $strTextmsg   = '"'.$arrStr[8].'"';
            if ( $intDataset==12 ) 
            {
            $intX = $arrStr[9];
            $intY = $arrStr[10];
            $intZ = $arrStr[11];
            }
            else
            {
            $intX = 0;
            $intY = 0;
            $intZ = 0;
            }

            $str  = 'INSERT INTO '.TABPOST;
            $str .= ' (id,forum,topic,type,userid,username,title,issuedate,textmsg) VALUES';
            $str .= " ($intPost,$intSection,$intTopic,$strType,0,$strUsername,$strTitle,$intIssuedate,$strTextmsg)";
            $oDB->Query($str);
            $intCountPost++;

            if ( ($arrStr[3]=='P') || ($arrStr[3]=='A') )
            {
              if ( $arrStr[3]=='P' ) $strType='"T"';
              if ( $arrStr[4]=='NULL' ) $arrStr[4]='Visitor';
              $str  = 'INSERT INTO '.TABTOPIC;
              $str .= ' (id,numid,forum,type,status,firstpostid,lastpostid,firstpostuser,lastpostuser,firstpostname,lastpostname,firstpostdate,lastpostdate,x,y,z) VALUES';
              $str .= " ($intTopic,$intNumid,$intSection,$strType,\"$strStatus\",$intPost,$intPost,0,0,$strUsername,$strUsername,$intIssuedate,$intIssuedate,$intX,$intY,$intZ)";
              $oDB->Query($str);
              $intCountTopic++;
            }
          }
          else
          {
            $qti_error='Number of parameters ('.count($arrStr).') not matching in line '.$i;
          }
        }
        else
        {
        $qti_error='Not enough delimiters ('.substr_count($str, $strDelimit).') in line '.$i;
        }
      }
      // ----
      fclose($handle);

      // udate stats
      if ( $intCountPost>0 || $intCountTopic>0 )
      {
      UpdateSectionStats($oDB,$intSection);
      }
    }
  }

  if ( empty($qti_error) )
  {
    unlink($_FILES['title']['tmp_name']);
    $oVIP->EndMessage(NULL,$L['import_qti']['S_import'],'admin',0);
  }
}

// --------
// HTML START
// --------

include('qti_adm_p_header.php');
include('qti_adm_p_title.php');

if ( isset($_SESSION['m_import_qti']) )
{
$strTitle   = $_SESSION['m_import_qti'][0];
$strFormat  = $_SESSION['m_import_qti'][1];
$strDelimit = $_SESSION['m_import_qti'][2];
$strEnclose = $_SESSION['m_import_qti'][3];
$strNull    = $_SESSION['m_import_qti'][4];
$strDropbbc = $_SESSION['m_import_qti'][5];
$strSkip    = $_SESSION['m_import_qti'][6];
$intSection   = $_SESSION['m_import_qti'][7];
$strStatus  = $_SESSION['m_import_qti'][8];
}

echo '
<script type="text/javascript">
<!--
function ValidateForm(theForm)
{
  if (theForm.title.value.length==0) { alert(html_entity_decode("',$L['E_mandatory'],': File")); return false; }
  return null;
}
-->
</script>
';

echo "<form method=\"post\" action=\"$oVIP->selfurl\" enctype=\"multipart/form-data\" onsubmit=\"return ValidateForm(this);\">\n";
echo '<input type="hidden" name="maxsize" value="5242880"/>',N;
echo '<table class="tab" cellspacing="0">',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_all" colspan="2">',$L['import_qti']['File'],'</th>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first" style="width:200px"><label for="title">',$L['import_qti']['File'],'</label></th>',N;
echo '<td class="td_o"><input type="file" id="title" name="title" size="32" value="',$strTitle,'"/></td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_all" colspan="2">',$L['Adm_settings'],'</th>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first"><label for="format">',$L['import_qti']['Format'],'</label></th>',N;
echo '<td class="td_o"><select id="format" name="format">',N;
echo '<option value="CSV"',($strFormat=='CSV' ? QSEL : ''),'>',$L['import_qti']['Csv'],'</option>',N;
echo '<option value="SQL"',($strFormat=='SQL' ? QSEL : ''),'>',$L['import_qti']['Sql'],'</option>',N;
echo '</select></td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first"><label for="delimit">',$L['import_qti']['Delimiter'],'</label></th>',N;
echo '<td class="td_o"><input type="text" id="delimit" name="delimit" size="1" maxlength="5" value="',$strDelimit,'"/></td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first"><label for="enclose">',$L['import_qti']['Encloser'],'</label></th>',N;
echo '<td class="td_o"><input type="text" id="enclose" name="enclose" size="1" maxlength="5" value="',htmlspecialchars($strEnclose),'"/></td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first"><label for="null">',$L['import_qti']['Null'],'</label></th>',N;
echo '<td class="td_o"><input type="text" id="null" name="null" size="5" maxlength="24" value="',$strNull,'"/> ',$L['import_qti']['H_Null'],'</td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first">',$L['import_qti']['First_line'],'</th>',N;
echo '<td class="td_o"><input type="checkbox" id="skip" name="skip"',($strSkip=='Y' ? QCHE : ''),'/><label for="skip">',$L['import_qti']['HFirst_line'],'</label></td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_all" colspan="2">',$L['Destination'],'</th>',N;
echo '</tr>',N;

echo '<tr class="tr_t">
<th class="th_o th_o_first" style="width:200px"><label for="section">',$L['import_qti']['Destination'],'</label></th>
<td class="td_o"><select id="section" name="section">',QTastags(GetSectionTitles($oDB,'A')),'</select> <a href="qti_adm_sections.php">',$L['Section_add'],'</a></td>
</tr>
';
echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first">',$L['import_qti']['Drop_bbc'],'</th>',N;
echo '<td class="td_o"><input type="checkbox" id="dropbbc" name="dropbbc"',($strDropbbc=='Y' ? QCHE : ''),'/><label for="dropbbc">',$L['import_qti']['HDrop_bbc'],'</label></td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_first"><label for="status">',$L['Status'],'</label></th>',N;
echo '<td class="td_o"><select id="status" name="status">';
foreach ($_SESSION['qtiTstatus'] as $strKey => $arrValues)
{
echo '<option value="',$strKey,'"',($strStatus==$strKey ? QSEL : ''),">$strKey {$arrValues['name']}</option>",N;
}
echo '</select></td>',N;
echo '</tr>',N;

echo '<tr class="tr_t">',N;
echo '<th class="th_o th_o_all" colspan="2" style="padding:6px; text-align:center"><input type="submit" name="ok" value="',$L['Ok'],'"/></th>',N;
echo '</tr>',N;

echo '</table>',N,'</form>',N;

// HTML END

include('qti_adm_p_footer.php');

?>